/*

 WatchDog 1.1

 Example: use redirect ps.exe output to queue to get process list
 and keep processes, listed in KeepList on the run. If one of them down,
 Watchdog restart it after TimeOut

 You may realize it for pstat also

 Keeplist format:
 - no comments allowed
 - no no empty strings allowed
 - process name IN UPPERCASE only
 - processname with full path
 
*/

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

KeepListName='keep.me'
TimeOut = 10

rec = ReadTextFile( KeepListName  , "KeepList_" )
   if rec = 0 then
   do forever
     KeepList.0 = KeepList_.0; do i=1 to KeepList_.0; KeepList.i = KeepList_.i; end
     '@PS | RXQUEUE'
     DO WHILE QUEUED()<>0 /* scan queue */
     origin = linein("QUEUE:")
        do i = 1 to KeepList.0 /* scan list of keeped processes */
        if pos(KeepList.i,origin)<>0 then /* OK, we found process, his name no more needed */
           do
     		do j = i to KeepList.0-1
		KeepList.j = Value('KeepList.'||Value(j+1))
		end
           KeepList.0 = KeepList.0 - 1
           end
         end /* scan list of keeped processes */
     END /* scan queue */
	do j = 1 to KeepList.0
 /*  ⠢  ᪠    */
        '@start /c 'Keeplist.j
	end
   call SysSleep(TimeOut)
   end /* do forever */
   else
     say 'Error '||rc
  
exit



 
     

 

  
 /* ------------------------------------------------------------------ */
 /* function: Read a text file into a compound variable                */
 /*                                                                    */
 /* call:     ReadTextFile fileName, stem                              */
 /*                                                                    */
 /* where:    fileName - name of the file to read                      */
 /*           stem - stem for the lines of the file                    */
 /*                                                                    */
 /* returns:  0 - okay, file read, the compound variable "stem"        */
 /*                     contains the lines of the file,                */
 /*                     "stem".0 = no. of lines                        */
 /*           else error reading the file                              */
 /*                                                                    */
 ReadTextFile:
   parse arg rtf.__fileName , rtf.__stemName
 
                         /* set the return code                        */
   rc = -1
 
   rtf.__i = i
 
   if rtf.__fileName <> "" & rtf.__stemName <> "" then
   do
     if right( rtf.__stemName,1 ) <> "." then
       rtf.__StemName = rtf.__StemName || "."
 
                         /* init the number of stem elements with 0    */
     rtf.__iLine = rtf.__StemName || "0 = 0 "
     interpret rtf.__iLine
 
                         /* set the return code 2 - file not found     */
     rc = 2
 
     if stream( rtf.__fileName, "c", "QUERY EXIST" ) <> "" then
     do
 
                         /* set return code to 0                       */
       rc = 0
 
                         /* create the code to read the file           */
       rtf.__iLine = ,
        "do i = 1 until lines( """ || rtf.__fileName || """ ) = 0; "  ,
           rtf.__StemName || "i = lineIn( '" || rtf.__fileName || "');" ,
        "end;"
                         /* and now execute the code to read the file  */
       interpret rtf.__iLine
 
                         /* close the file                             */
       call stream rtf.__fileName, "c", "CLOSE"
 
                         /* correct the no. of lines in stem.0         */
       rtf.__iLine = rtf.__StemName || "0 = i "
       interpret rtf.__iLine
 
     end /* if stream( ... */
 
   end /* if rtf.__fileName <> "" & ... */
 
   i = rtf.__i
   drop rtf.
 
 RETURN rc
 
 
   

